#include "thinkeramik.h"
#include <qlayout.h>
#include <kapp.h>
#include <ksimpleconfig.h>
#include <klocale.h>
#include <qvbuttongroup.h>
#include <qvgroupbox.h>
#include <qlayout.h>
#include <qhbox.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qtabwidget.h>
#include <qslider.h>
#include <qlabel.h>
#include <kcolorbutton.h>
#include <qsettings.h>
#include <kipc.h>

void ThinKeramikConfig::save()
{
    QSettings *settings = new QSettings;
    QString aValue;
    if(useCustomColorBtn1->isOn()){
        settings->writeEntry("/qt/ThinKmk/MenuBG",  "#" + aValue.sprintf("%06x",
                             (menuBgBtn->color().red()*65536 + menuBgBtn->color().green()*256 + menuBgBtn->color().blue())) );
        settings->writeEntry("/qt/ThinKmk/MenuStripe", "#" +  aValue.sprintf("%06x",
			     (menuStripeBtn->color().red()*65536 + menuStripeBtn->color().green()*256 + menuStripeBtn->color().blue())) );
    } else {
        settings->removeEntry("/qt/ThinKmk/MenuBG");
        settings->removeEntry("/qt/ThinKmk/MenuStripe");
    }

    settings->writeEntry("/qt/ThinKmk/EnableGradation", enableGradBtn->isOn());
    if (enableGradBtn->isOn()) {
        settings->writeEntry("/qt/ThinKmk/CustomGradation", customGradBtn->isOn());
    } else {
        settings->removeEntry("/qt/ThinKmk/CustomGradation");
    }

    if(useCustomColorBtn1b->isOn()){
        settings->writeEntry("/qt/ThinKmk/MenuBorder", "#" + aValue.sprintf("%06x",
			     (borderColBtn->color().red()*65536 + borderColBtn->color().green()*256 + borderColBtn->color().blue())) );
    } else {
        settings->removeEntry("/qt/ThinKmk/MenuBorder");
    }

    if(useCustomColorBtn2->isOn()){
        settings->writeEntry("/qt/ThinKmk/ActiveTab", "#" + aValue.sprintf("%06x",
			     (activeTabBtn->color().red()*65536 + activeTabBtn->color().green()*256 + activeTabBtn->color().blue())) );
    } else {
        settings->removeEntry("/qt/ThinKmk/ActiveTab");
    }

    settings->writeEntry("/qt/ThinKmk/DisableUpperLines", disableUpperLinesBtn->isOn());

    if(useCustomColorBtn3->isOn()){
        settings->writeEntry("/qt/ThinKmk/Scrollbar", "#" + aValue.sprintf("%06x",
			     (scrollbarBtn->color().red()*65536 + scrollbarBtn->color().green()*256 + scrollbarBtn->color().blue())) );
        settings->writeEntry("/qt/ThinKmk/ScrollArrowbtn", "#" + aValue.sprintf("%06x",
			     (scrollArbBtn->color().red()*65536 + scrollArbBtn->color().green()*256 + scrollArbBtn->color().blue())) );
    } else {
        settings->removeEntry("/qt/ThinKmk/Scrollbar");
        settings->removeEntry("/qt/ThinKmk/ScrollArrowbtn");
    }

    if(useCustomColorBtn4->isOn()){
        settings->writeEntry("/qt/ThinKmk/ButtonPrelight", "#" + aValue.sprintf("%06x",
			     (btnprlBtn->color().red()*65536 + btnprlBtn->color().green()*256 + btnprlBtn->color().blue())) );
    } else {
        settings->removeEntry("/qt/ThinKmk/ButtonPrelight");
    }

    settings->writeEntry("/qt/ThinKmk/UseShadowTextMenu", useShdM->isOn());
    settings->writeEntry("/qt/ThinKmk/UseShadowTextMenuBar", useShdMB->isOn());
    settings->writeEntry("/qt/ThinKmk/UseShadowTextButton", useShdB->isOn());
    settings->writeEntry("/qt/ThinKmk/UseShadowTextTab", useShdT->isOn());

    delete settings; // force sync
    KIPC::sendMessageAll(KIPC::StyleChanged, 0);
    emit changed(false);
}


void ThinKeramikConfig::load()
{
    QSettings settings;

    QString mbgcolstr = settings.readEntry("/qt/ThinKmk/MenuBG");
    QString mstcolstr = settings.readEntry("/qt/ThinKmk/MenuStripe");

    if (!mbgcolstr.isNull() && !mstcolstr.isNull()) {
          useCustomColorBtn1->setChecked(true);
	  menuBgBtn->setColor(QColor(mbgcolstr));
	  menuStripeBtn->setColor(QColor(mstcolstr));
    } else {
          useCustomColorBtn1->setChecked(false);
	  menuBgBtn->setColor(colorGroup().background().light(110));
	  menuStripeBtn->setColor(colorGroup().mid());
    }

    enableGradBtn->setChecked(settings.readBoolEntry("/qt/ThinKmk/EnableGradation"));
    customGradBtn->setChecked(settings.readBoolEntry("/qt/ThinKmk/CustomGradation"));

    QString bordercolstr = settings.readEntry("/qt/ThinKmk/MenuBorder");

    if (!bordercolstr.isNull()) {
          useCustomColorBtn1b->setChecked(true);
	  borderColBtn->setColor(QColor(bordercolstr));
    } else {
          useCustomColorBtn1b->setChecked(false);
	  borderColBtn->setColor(colorGroup().shadow());
    }

    QString atcolstr = settings.readEntry("/qt/ThinKmk/ActiveTab");

    if (!atcolstr.isNull()) {
          useCustomColorBtn2->setChecked(true);
	  activeTabBtn->setColor(QColor(atcolstr));
    } else {
          useCustomColorBtn2->setChecked(false);
	  activeTabBtn->setColor(colorGroup().highlight());
    }

    disableUpperLinesBtn->setChecked(settings.readBoolEntry("/qt/ThinKmk/DisableUpperLines"));

    QString sbcolstr = settings.readEntry("/qt/ThinKmk/Scrollbar");
    QString sacolstr = settings.readEntry("/qt/ThinKmk/ScrollArrowbtn");
    if (sacolstr.isNull() && !sbcolstr.isNull()) {
          sacolstr = sbcolstr;
    }

    if (!sbcolstr.isNull()) {
          useCustomColorBtn3->setChecked(true);
	  scrollbarBtn->setColor(QColor(sbcolstr));
	  scrollArbBtn->setColor(QColor(sacolstr));
    } else {
          useCustomColorBtn3->setChecked(false);
	  scrollbarBtn->setColor(QColor(settings.readEntry("/qt/KWinPalette/inactiveBackground", "#d8d8d8")));
	  scrollArbBtn->setColor(QColor(settings.readEntry("/qt/KWinPalette/inactiveBackground", "#d8d8d8")));
    }

    QString btnprlcolstr = settings.readEntry("/qt/ThinKmk/ButtonPrelight");
    if (!btnprlcolstr.isNull()) {
          useCustomColorBtn4->setChecked(true);
	  btnprlBtn->setColor(QColor(btnprlcolstr));
    } else {
          useCustomColorBtn4->setChecked(false);
	  btnprlBtn->setColor(colorGroup().button().light(105));
    }

    useShdM->setChecked(settings.readBoolEntry("/qt/ThinKmk/UseShadowTextMenu"));
    useShdMB->setChecked(settings.readBoolEntry("/qt/ThinKmk/UseShadowTextMenuBar"));
    useShdB->setChecked(settings.readBoolEntry("/qt/ThinKmk/UseShadowTextButton"));
    useShdT->setChecked(settings.readBoolEntry("/qt/ThinKmk/UseShadowTextTab"));

    slotUseCustomColor1Clicked(useCustomColorBtn1->isChecked());
    slotUseCustomColor1bClicked(useCustomColorBtn1b->isChecked());
    slotEnableGradClicked(enableGradBtn->isChecked());
    slotUseCustomColor2Clicked(useCustomColorBtn2->isChecked());
    slotDisableUpperLinesClicked(disableUpperLinesBtn->isChecked());
    slotUseCustomColor3Clicked(useCustomColorBtn3->isChecked());
    slotUseCustomColor4Clicked(useCustomColorBtn4->isChecked());
    slotBtnColorChanged(colorGroup().background());
    emit changed(false);
}

void ThinKeramikConfig::defaults()
{
    load();
    emit changed(true);
}

void ThinKeramikConfig::slotBtnColorChanged(const QColor &)
{
    emit changed(true);
}

void ThinKeramikConfig::slotCheckBtnClicked(bool en)
{
    emit changed(true);
}

void ThinKeramikConfig::slotSliderChanged(int)
{
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor1Clicked(bool en)
{
    menuBgBtn->setEnabled(en);
    menuStripeBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor1bClicked(bool en)
{
    borderColBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotEnableGradClicked(bool en)
{
    customGradBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor2Clicked(bool en)
{
    activeTabBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotDisableUpperLinesClicked(bool en)
{
    useCustomColorBtn2->setEnabled(!en);
    activeTabBtn->setEnabled(useCustomColorBtn2->isOn() && !disableUpperLinesBtn->isOn());
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor3Clicked(bool en)
{
    scrollbarBtn->setEnabled(en);
    scrollArbBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor4Clicked(bool en)
{
    btnprlBtn->setEnabled(en);
    emit changed(true);
}

ThinKeramikConfig::ThinKeramikConfig(QWidget *parent, const char *name)
    : KCModule(parent, name)
{
    QVBoxLayout *layout = new QVBoxLayout(this);
    QTabWidget *tabWidget = new QTabWidget(this);
    layout->addWidget(tabWidget);

    //--- tab 1 ---

    QWidget *page1 = new QWidget(tabWidget);
    tabWidget->insertTab(page1, i18n("Menu Options"));

    layout = new QVBoxLayout(page1);
    layout->addSpacing(5);

    // Menu colors
    QVGroupBox *colorGrp1 = new QVGroupBox(i18n("Menu colors"), page1);
    QWidget *colorFrame1  = new QWidget(colorGrp1);
    QGridLayout *cLayout1 = new QGridLayout(colorFrame1, 1, 1, 5);

    useCustomColorBtn1 = new QCheckBox(i18n("Use custom colors"), colorFrame1);
    cLayout1->addMultiCellWidget(useCustomColorBtn1, 1, 1, 0, 3);

    cLayout1->addWidget(new QLabel(i18n("Widget:"), colorFrame1), 2, 0);
    cLayout1->addWidget(new QLabel(i18n("Color:"), colorFrame1), 2, 1);

    cLayout1->addWidget(new QLabel(i18n("Background:"), colorFrame1), 3, 0);
    cLayout1->addWidget(new QLabel(i18n("Stripe:"), colorFrame1), 4, 0);

    menuBgBtn = new KColorButton(colorFrame1);
    cLayout1->addWidget(menuBgBtn, 3, 1);
    menuStripeBtn = new KColorButton(colorFrame1);
    cLayout1->addWidget(menuStripeBtn, 4, 1);

    cLayout1->addMultiCellWidget(new QLabel(i18n("Custom menu colors are effective in"), colorFrame1), 5, 5, 0, 3);
    cLayout1->addMultiCellWidget(new QLabel(i18n("XRender-Blend mode or Disable-Translucent mode."), colorFrame1), 6, 6, 1, 3);

    enableGradBtn = new QCheckBox(i18n("Enable gradation in the XRender-Blend mode"), colorFrame1);
    cLayout1->addMultiCellWidget(enableGradBtn, 7, 7, 0, 3);

    customGradBtn = new QCheckBox(i18n("Custom gradation (Background color to Stripe color)"), colorFrame1);
    cLayout1->addMultiCellWidget(customGradBtn, 8, 8, 1, 3);

    connect(useCustomColorBtn1, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor1Clicked(bool)));
    connect(menuBgBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(menuStripeBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(enableGradBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotEnableGradClicked(bool)));
    connect(customGradBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    cLayout1->setColStretch(3, 1);
    layout->addWidget(colorGrp1);
    layout->addSpacing(5);

    // Menu Border
    QVGroupBox *colorGrp1b = new QVGroupBox(i18n("Menu Border"), page1);
    useCustomColorBtn1b = new QCheckBox(i18n("Draw menu border"), colorGrp1b);
    connect(useCustomColorBtn1b, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor1bClicked(bool)));
    QHBox *colorBox1b = new QHBox(colorGrp1b);
    QLabel *borderColBtnLbl = new QLabel(i18n("Border color:"), colorBox1b);
    borderColBtn = new KColorButton(colorBox1b);
    connect(borderColBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    colorBox1b->setStretchFactor(new QWidget(colorBox1b), 1);
    layout->addWidget(colorGrp1b);

    layout->addStretch(1);

    //--- tab 2 ---

    QWidget *page2 = new QWidget(tabWidget);
    layout = new QVBoxLayout(page2);
    layout->addSpacing(5);

    tabWidget->insertTab(page2, i18n("Custom Colors"));

    // Upper lines of Active Tab
    QVGroupBox *colorGrp2 = new QVGroupBox(i18n("Upper lines of Active Tab"), page2);
    useCustomColorBtn2 = new QCheckBox(i18n("Use custom color"), colorGrp2);
    connect(useCustomColorBtn2, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor2Clicked(bool)));
    QHBox *colorBox2 = new QHBox(colorGrp2);
    QLabel *activeTabLbl = new QLabel(i18n("Custom color:"), colorBox2);
    activeTabBtn = new KColorButton(colorBox2);
    connect(activeTabBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    colorBox2->setStretchFactor(new QWidget(colorBox2), 1);
    disableUpperLinesBtn = new QCheckBox(i18n("Disable upper lines"), colorGrp2);
    connect(disableUpperLinesBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotDisableUpperLinesClicked(bool)));
    layout->addWidget(colorGrp2);
    layout->addSpacing(5);

    // Scrollbar colors
    QVGroupBox *colorGrp3 = new QVGroupBox(i18n("Scrollbar colors"), page2);
    QWidget *colorFrame3  = new QWidget(colorGrp3);
    QGridLayout *cLayout3 = new QGridLayout(colorFrame3, 1, 1, 5);

    useCustomColorBtn3 = new QCheckBox(i18n("Use custom colors"), colorFrame3);
    cLayout3->addMultiCellWidget(useCustomColorBtn3, 1, 1, 0, 3);

    cLayout3->addWidget(new QLabel(i18n("Widget:"), colorFrame3), 2, 0);
    cLayout3->addWidget(new QLabel(i18n("Color:"), colorFrame3), 2, 1);

    cLayout3->addWidget(new QLabel(i18n("Slider:"), colorFrame3), 3, 0);
    cLayout3->addWidget(new QLabel(i18n("Arrow Button:"), colorFrame3), 4, 0);

    scrollbarBtn = new KColorButton(colorFrame3);
    cLayout3->addWidget(scrollbarBtn, 3, 1);
    scrollArbBtn = new KColorButton(colorFrame3);
    cLayout3->addWidget(scrollArbBtn, 4, 1);

    connect(useCustomColorBtn3, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor3Clicked(bool)));
    connect(scrollbarBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(scrollArbBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));

    cLayout3->setColStretch(3, 1);
    layout->addWidget(colorGrp3);

    layout->addSpacing(5);

    // Push button prelight
    QVGroupBox *colorGrp4 = new QVGroupBox(i18n("Push button prelight"), page2);
    useCustomColorBtn4 = new QCheckBox(i18n("Use custom color"), colorGrp4);
    connect(useCustomColorBtn4, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor4Clicked(bool)));
    QHBox *colorBox4 = new QHBox(colorGrp4);
    QLabel *btnprlLbl = new QLabel(i18n("Custom color:"), colorBox4);
    btnprlBtn = new KColorButton(colorBox4);
    connect(btnprlBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    colorBox4->setStretchFactor(new QWidget(colorBox4), 1);

    layout->addWidget(colorGrp4);

    layout->addStretch(1);

    //--- tab 3 ---

    QWidget *page3 = new QWidget(tabWidget);
    layout = new QVBoxLayout(page3);
    layout->addSpacing(5);

    tabWidget->insertTab(page3, i18n("Others"));

    // Use Shadowed Text
    QVGroupBox *otherGrp1 = new QVGroupBox(i18n("Use Shadowed Text"), page3);
    useShdM = new QCheckBox(i18n("Menu"), otherGrp1);
    useShdMB = new QCheckBox(i18n("Menu bar"), otherGrp1);
    useShdB = new QCheckBox(i18n("Push button"), otherGrp1);
    useShdT = new QCheckBox(i18n("Tab"), otherGrp1);

    connect(useShdM, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useShdMB, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useShdB, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useShdT, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    layout->addWidget(otherGrp1);
    layout->addStretch(1);

    load();

    menuBgBtn->setEnabled(useCustomColorBtn1->isOn());
    menuStripeBtn->setEnabled(useCustomColorBtn1->isOn());

    borderColBtn->setEnabled(useCustomColorBtn1b->isOn());

    customGradBtn->setEnabled(enableGradBtn->isOn());

    activeTabBtn->setEnabled(useCustomColorBtn2->isOn() && !disableUpperLinesBtn->isOn());
    useCustomColorBtn2->setEnabled(!disableUpperLinesBtn->isOn());

    scrollbarBtn->setEnabled(useCustomColorBtn3->isOn());
    scrollArbBtn->setEnabled(useCustomColorBtn3->isOn());

    btnprlBtn->setEnabled(useCustomColorBtn4->isOn());
}

ThinKeramikConfig::~ThinKeramikConfig()
{
    ;
}



#include "thinkeramik.moc"
















